#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy2 Experiment Builder (v1.84.2),
    on October 07, 2017, at 12:06
If you publish work using this script please cite the PsychoPy publications:
    Peirce, JW (2007) PsychoPy - Psychophysics software in Python.
        Journal of Neuroscience Methods, 162(1-2), 8-13.
    Peirce, JW (2009) Generating stimuli for neuroscience using PsychoPy.
        Frontiers in Neuroinformatics, 2:10. doi: 10.3389/neuro.11.010.2008
"""
# Jo's date: 19/10/2017#
from __future__ import absolute_import, division
from psychopy import locale_setup, gui, visual, core, data, event, logging, sound
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)
import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle
import os  # handy system and path functions
import sys  # to get file system encoding
reload(sys)
sys.setdefaultencoding('utf-8')

# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__)).decode(sys.getfilesystemencoding())
os.chdir(_thisDir)

# Store info about the experiment session
expName = 'Expt5_LHSprime_break'  # from the Builder filename that created this script
expInfo = {u'session': u'001', u'participant': u''}
dlg = gui.DlgFromDict(dictionary=expInfo, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath=None,
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp

# Start Code - component code to be run before the window creation

# Setup the Window
win = visual.Window(
    size=(1920, 1080), fullscr=True, screen=0,
    allowGUI=False, allowStencil=False,
    monitor='testMonitor', color=[0,0,0], colorSpace='rgb',
    blendMode='avg', useFBO=True)
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess

# Initialize components for Routine "Instructions"
InstructionsClock = core.Clock()
import numpy
# Setup the Window
win = visual.Window(
    size=(1600, 900), fullscr=True, screen=0,
    allowGUI=False, allowStencil=False,
    monitor='testMonitor', color=[1,1,1], colorSpace='rgb',
    blendMode='avg', useFBO=True)
writteninstructions = visual.TextStim(win=win, name='writteninstructions',
    text='In this experiment, you will be asked to solve some maths problems. The problems will be presented on the screen, one at a time. \n\nPlease solve each problem in your head (you are not allowed to write calculations down). Please say your answer out loud, and press the spacebar at the same time. \n\nYou only need to press the spacebar, the experimenter will enter your answer on a separate keypad. Please press the spacebar to continue.',
    font='Arial',
    pos=(0, 0), height=0.075, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=-1.0);

# Initialize components for Routine "fixation"
fixationClock = core.Clock()
fix = visual.TextStim(win=win, name='fix',
    text='*',
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "ncontrial"
ncontrialClock = core.Clock()
ncon = visual.TextStim(win=win, name='ncon',
    text='default text',
    font='Arial',
    pos=(0, 0), height=0.15, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "Pause"
PauseClock = core.Clock()
Pleaserest = visual.TextStim(win=win, name='Pleaserest',
    text='Please take a break.\n\nIf you have any questions, please ask the experimenter now. Do not ask the experimenter any questions after this point. \n\nPress the spacebar to continue.',
    font='Arial',
    pos=(0, 0), height=0.075, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "fixation"
fixationClock = core.Clock()
fix = visual.TextStim(win=win, name='fix',
    text='*',
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "trial"
trialClock = core.Clock()
prime = visual.TextStim(win=win, name='prime',
    text='default text',
    font='Arial',
    pos=(-0.132, 0), height=0.15, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=0.0);
maths = visual.TextStim(win=win, name='maths',
    text='default text',
    font='Arial',
    pos=(0, 0), height=0.15, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1,
    depth=-1.0);
from psychopy import locale_setup, gui, visual, core, data, event, logging, sound
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)
import numpy as np
from numpy import (sin, cos, tan, log, log10, pi, average, median, mean,#some of these help in CI calculations
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle
import os  # handy system and path functions
import sys  # to get file system encoding
import random
import time


if endExpNow or event.getKeys(keyList=["escape"]):
   core.quit()

#set-up counts for the number of conducive and non-conducive stimuli that have been presented
conducive_count = 0
nonconducive_count = 0

#set-up conducive reaction time variables
cRT1 = 0
cRT2 = 0
cRT3 = 0
cRT4 = 0
cRT5 = 0
cRT6 = 0
cRT7 = 0
cRT8 = 0
cRT9 = 0
cRT10 = 0
cRT11 = 0
cRT12 = 0
cRT13 = 0
cRT14 = 0
cRT15 = 0
cRT16 = 0
cRT17 = 0
cRT18 = 0
cRT19 = 0
cRT20 = 0
cRT21 = 0

#set-up Non-conducive reaction time variables
nRT1 = 0
nRT2 = 0
nRT3 = 0
nRT4 = 0
nRT5 = 0
nRT6 = 0
nRT7 = 0
nRT8 = 0
nRT9 = 0
nRT10 = 0
nRT11 = 0
nRT12 = 0
nRT13 = 0
nRT14 = 0
nRT15 = 0
nRT16 = 0
nRT17 = 0
nRT18 = 0
nRT19 = 0
nRT20 = 0
nRT21 = 0

#set-up variables for the rolling means of the non-conducive trials
nmean1 = 0
nmean2 = 0
nmean3 = 0
nmean4 = 0
nmean5 = 0
nmean6 = 0
nmean7 = 0
nmean8 = 0
nmean9 = 0
nmean10 = 0
nmean11 = 0
nmean12 = 0
nmean13 = 0
nmean14 = 0
nmean15 = 0
nmean16 = 0
nmean17 = 0
nmean18 = 0
nmean19 = 0
nmean20 = 0
nmean21 = 0

#set-up variables for the SD's of the non-conducive trials
nsd1 = 0
nsd2 = 0
nsd3 = 0
nsd4 = 0
nsd5 = 0
nsd6 = 0
nsd7 = 0
nsd8 = 0
nsd9 = 0
nsd10 = 0
nsd11 = 0
nsd12 = 0
nsd13 = 0
nsd14 = 0
nsd15 = 0
nsd16 = 0
nsd17 = 0
nsd18 = 0
nsd19 = 0
nsd21 = 0



#variables used for calculating confidence intervals of non-conducive trials
lconf = 0 #lower endpoint of the confidence interval of the non-conducive mean RT. 
bazinga = 0 # variable for the noise that will be presented when the identification point is hit
trial_num = 0 #count the trial number
med = 0 #variable for the rolling median of the conducive trials.

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# ------Prepare to start Routine "Instructions"-------
t = 0
InstructionsClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat

key_resp_3 = event.BuilderKeyResponse()
# keep track of which components have finished
InstructionsComponents = [writteninstructions, key_resp_3]
for thisComponent in InstructionsComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "Instructions"-------
while continueRoutine:
    # get current time
    t = InstructionsClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    
    # *writteninstructions* updates
    if t >= 0 and writteninstructions.status == NOT_STARTED:
        # keep track of start time/frame for later
        writteninstructions.tStart = t
        writteninstructions.frameNStart = frameN  # exact frame index
        writteninstructions.setAutoDraw(True)
    
    # *key_resp_3* updates
    if t >= 0.0 and key_resp_3.status == NOT_STARTED:
        # keep track of start time/frame for later
        key_resp_3.tStart = t
        key_resp_3.frameNStart = frameN  # exact frame index
        key_resp_3.status = STARTED
        # keyboard checking is just starting
        win.callOnFlip(key_resp_3.clock.reset)  # t=0 on next screen flip
        event.clearEvents(eventType='keyboard')
    if key_resp_3.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            key_resp_3.keys = theseKeys[-1]  # just the last key pressed
            key_resp_3.rt = key_resp_3.clock.getTime()
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in InstructionsComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "Instructions"-------
for thisComponent in InstructionsComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)

# check responses
if key_resp_3.keys in ['', [], None]:  # No response was made
    key_resp_3.keys=None
thisExp.addData('key_resp_3.keys',key_resp_3.keys)
if key_resp_3.keys != None:  # we had a response
    thisExp.addData('key_resp_3.rt', key_resp_3.rt)
thisExp.nextEntry()
# the Routine "Instructions" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
trials_2 = data.TrialHandler(nReps=1, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('Practice trials.xlsx'),
    seed=None, name='trials_2')
thisExp.addLoop(trials_2)  # add the loop to the experiment
thisTrial_2 = trials_2.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTrial_2.rgb)
if thisTrial_2 != None:
    for paramName in thisTrial_2.keys():
        exec(paramName + '= thisTrial_2.' + paramName)

for thisTrial_2 in trials_2:
    currentLoop = trials_2
    # abbreviate parameter names if possible (e.g. rgb = thisTrial_2.rgb)
    if thisTrial_2 != None:
        for paramName in thisTrial_2.keys():
            exec(paramName + '= thisTrial_2.' + paramName)
    
    # ------Prepare to start Routine "fixation"-------
    t = 0
    fixationClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(0.500000)
    # update component parameters for each repeat
    # keep track of which components have finished
    fixationComponents = [fix]
    for thisComponent in fixationComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "fixation"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = fixationClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *fix* updates
        if t >= 0.0 and fix.status == NOT_STARTED:
            # keep track of start time/frame for later
            fix.tStart = t
            fix.frameNStart = frameN  # exact frame index
            fix.setAutoDraw(True)
        frameRemains = 0.0 + 0.5- win.monitorFramePeriod * 0.75  # most of one frame period left
        if fix.status == STARTED and t >= frameRemains:
            fix.setAutoDraw(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in fixationComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "fixation"-------
    for thisComponent in fixationComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    
    # ------Prepare to start Routine "ncontrial"-------
    t = 0
    ncontrialClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    ncon.setText(Problem)
    solved = event.BuilderKeyResponse()
    ans = event.BuilderKeyResponse()
    key_resp_2 = event.BuilderKeyResponse()
    # keep track of which components have finished
    ncontrialComponents = [ncon, solved, ans, key_resp_2]
    for thisComponent in ncontrialComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "ncontrial"-------
    while continueRoutine:
        # get current time
        t = ncontrialClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *ncon* updates
        if t >= 0.25 and ncon.status == NOT_STARTED:
            # keep track of start time/frame for later
            ncon.tStart = t
            ncon.frameNStart = frameN  # exact frame index
            ncon.setAutoDraw(True)
        
        # *solved* updates
        if t >= 0.0 and solved.status == NOT_STARTED:
            # keep track of start time/frame for later
            solved.tStart = t
            solved.frameNStart = frameN  # exact frame index
            solved.status = STARTED
            # keyboard checking is just starting
            win.callOnFlip(solved.clock.reset)  # t=0 on next screen flip
            event.clearEvents(eventType='keyboard')
        if solved.status == STARTED:
            theseKeys = event.getKeys(keyList=['space'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                solved.keys = theseKeys[-1]  # just the last key pressed
                solved.rt = solved.clock.getTime()
        
        # *ans* updates
        if t >= 0.0 and ans.status == NOT_STARTED:
            # keep track of start time/frame for later
            ans.tStart = t
            ans.frameNStart = frameN  # exact frame index
            ans.status = STARTED
            # keyboard checking is just starting
            win.callOnFlip(ans.clock.reset)  # t=0 on next screen flip
            event.clearEvents(eventType='keyboard')
        if ans.status == STARTED:
            theseKeys = event.getKeys(keyList=['num_1', 'num_2', 'num_3', 'num_4', 'num_5', 'num_6', 'num_7', 'num_8', 'num_9', 'num_0'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                ans.keys.extend(theseKeys)  # storing all keys
                ans.rt.append(ans.clock.getTime())
        
        # *key_resp_2* updates
        if t >= 0.0 and key_resp_2.status == NOT_STARTED:
            # keep track of start time/frame for later
            key_resp_2.tStart = t
            key_resp_2.frameNStart = frameN  # exact frame index
            key_resp_2.status = STARTED
            # keyboard checking is just starting
            win.callOnFlip(key_resp_2.clock.reset)  # t=0 on next screen flip
            event.clearEvents(eventType='keyboard')
        if key_resp_2.status == STARTED:
            theseKeys = event.getKeys(keyList=['enter', 'return'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                key_resp_2.keys = theseKeys[-1]  # just the last key pressed
                key_resp_2.rt = key_resp_2.clock.getTime()
                # a response ends the routine
                continueRoutine = False
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in ncontrialComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "ncontrial"-------
    for thisComponent in ncontrialComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if solved.keys in ['', [], None]:  # No response was made
        solved.keys=None
    trials_2.addData('solved.keys',solved.keys)
    if solved.keys != None:  # we had a response
        trials_2.addData('solved.rt', solved.rt)
    # check responses
    if ans.keys in ['', [], None]:  # No response was made
        ans.keys=None
    trials_2.addData('ans.keys',ans.keys)
    if ans.keys != None:  # we had a response
        trials_2.addData('ans.rt', ans.rt)
    # check responses
    if key_resp_2.keys in ['', [], None]:  # No response was made
        key_resp_2.keys=None
    trials_2.addData('key_resp_2.keys',key_resp_2.keys)
    if key_resp_2.keys != None:  # we had a response
        trials_2.addData('key_resp_2.rt', key_resp_2.rt)
    # the Routine "ncontrial" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 1 repeats of 'trials_2'


# ------Prepare to start Routine "Pause"-------
t = 0
PauseClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
key_resp_5 = event.BuilderKeyResponse()
# keep track of which components have finished
PauseComponents = [Pleaserest, key_resp_5]
for thisComponent in PauseComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "Pause"-------
while continueRoutine:
    # get current time
    t = PauseClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *Pleaserest* updates
    if t >= 0.0 and Pleaserest.status == NOT_STARTED:
        # keep track of start time/frame for later
        Pleaserest.tStart = t
        Pleaserest.frameNStart = frameN  # exact frame index
        Pleaserest.setAutoDraw(True)
    
    # *key_resp_5* updates
    if t >= 0.0 and key_resp_5.status == NOT_STARTED:
        # keep track of start time/frame for later
        key_resp_5.tStart = t
        key_resp_5.frameNStart = frameN  # exact frame index
        key_resp_5.status = STARTED
        # keyboard checking is just starting
        win.callOnFlip(key_resp_5.clock.reset)  # t=0 on next screen flip
        event.clearEvents(eventType='keyboard')
    if key_resp_5.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            key_resp_5.keys = theseKeys[-1]  # just the last key pressed
            key_resp_5.rt = key_resp_5.clock.getTime()
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in PauseComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "Pause"-------
for thisComponent in PauseComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if key_resp_5.keys in ['', [], None]:  # No response was made
    key_resp_5.keys=None
thisExp.addData('key_resp_5.keys',key_resp_5.keys)
if key_resp_5.keys != None:  # we had a response
    thisExp.addData('key_resp_5.rt', key_resp_5.rt)
thisExp.nextEntry()
# the Routine "Pause" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
trials = data.TrialHandler(nReps=1, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions(u'Attention experiment stimuli all.xlsx'),
    seed=None, name='trials')
thisExp.addLoop(trials)  # add the loop to the experiment
thisTrial = trials.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
if thisTrial != None:
    for paramName in thisTrial.keys():
        exec(paramName + '= thisTrial.' + paramName)

for thisTrial in trials:
    currentLoop = trials
    # abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
    if thisTrial != None:
        for paramName in thisTrial.keys():
            exec(paramName + '= thisTrial.' + paramName)
    
    # ------Prepare to start Routine "fixation"-------
    t = 0
    fixationClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    routineTimer.add(0.500000)
    # update component parameters for each repeat
    # keep track of which components have finished
    fixationComponents = [fix]
    for thisComponent in fixationComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "fixation"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = fixationClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *fix* updates
        if t >= 0.0 and fix.status == NOT_STARTED:
            # keep track of start time/frame for later
            fix.tStart = t
            fix.frameNStart = frameN  # exact frame index
            fix.setAutoDraw(True)
        frameRemains = 0.0 + 0.5- win.monitorFramePeriod * 0.75  # most of one frame period left
        if fix.status == STARTED and t >= frameRemains:
            fix.setAutoDraw(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in fixationComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "fixation"-------
    for thisComponent in fixationComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    
    # ------Prepare to start Routine "trial"-------
    t = 0
    trialClock.reset()  # clock
    frameN = -1
    continueRoutine = True
    # update component parameters for each repeat
    prime.setText(LHS)
    maths.setText(Problem_left)
    solved_arithmetic = event.BuilderKeyResponse()
    trial_num +=1 # count the trials
    
    #Note: the program goes through conducive/non-conducive problems in a set order (sequential). This was purposely chosen. To measure differences in identification points,
    #we need to ensure everyone has seen the exact same stimuli in the exact same order. To ensure every person sees the same stimuli in the same order, the following steps were taken:
    
    #1. CN order was chosen in advance. CN order was chosen randomly by excel (every two trials it must include a C and an N).
    #2. For the median (3) of the conducives, 3 types of conducive stimuli were created (three types of 'difficulty, list 1, list 2, list 3).
    #Within each type, they are judged to be of equivalent difficulty assuming L2R procedure but they may vary in 'identification' (this we do not know). 
    #On every 3 conducive trials, one of each tpye is experienced. For every 3 non-conducive trials one of each type is experienced. 
    #The order of the type of problem/difficulty was chosen randomly by excel for each problem type (conducive, non-conducive).
     
    #3. The exact problems assigned to the pre-set order (CN and within that, the difficulty order e.g. 1-2-3) was done by entering each list of problems into Python,
    #which shuffled each list and then printed the shuffled order. The problems were then assigned to the order (e.g. trial 1 = non-conducive and difficulty 3, trial 2 = conducive
    #and difficulty 1, etc
    
    Log = []# log is an empty list that the RT gets appended to. This RT is then popped into later (median/mean) calculations
    
    #On each trial, record whether the stimulus is conducive or non-conducive. This enables two calculations to be performed on every appropriate trial - one for the median
    #of the conducives and one for the mean of the non-conducives.
    if Ptype == 1:
        conducive_count +=1
    if Ptype == 2:
        nonconducive_count +=1
    
    play = Problem_left #record the maths problem in a variable
    
    
    
    arithmetic_answer = event.BuilderKeyResponse()
    experimenter_ends = event.BuilderKeyResponse()
    # keep track of which components have finished
    trialComponents = [prime, maths, solved_arithmetic, arithmetic_answer, experimenter_ends]
    for thisComponent in trialComponents:
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    
    # -------Start Routine "trial"-------
    while continueRoutine:
        # get current time
        t = trialClock.getTime()
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *prime* updates
        if t >= 0.0 and prime.status == NOT_STARTED:
            # keep track of start time/frame for later
            prime.tStart = t
            prime.frameNStart = frameN  # exact frame index
            prime.setAutoDraw(True)
        frameRemains = 0.0 + 0.25- win.monitorFramePeriod * 0.75  # most of one frame period left
        if prime.status == STARTED and t >= frameRemains:
            prime.setAutoDraw(False)
        
        # *maths* updates
        if t >= 0.25 and maths.status == NOT_STARTED:
            # keep track of start time/frame for later
            maths.tStart = t
            maths.frameNStart = frameN  # exact frame index
            maths.setAutoDraw(True)
        
        # *solved_arithmetic* updates
        if t >= 0.0 and solved_arithmetic.status == NOT_STARTED:
            # keep track of start time/frame for later
            solved_arithmetic.tStart = t
            solved_arithmetic.frameNStart = frameN  # exact frame index
            solved_arithmetic.status = STARTED
            # keyboard checking is just starting
            win.callOnFlip(solved_arithmetic.clock.reset)  # t=0 on next screen flip
            event.clearEvents(eventType='keyboard')
        if solved_arithmetic.status == STARTED:
            theseKeys = event.getKeys(keyList=['space'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                solved_arithmetic.keys.extend(theseKeys)  # storing all keys
                solved_arithmetic.rt = solved_arithmetic.clock.getTime()
                Log.append(solved_arithmetic.rt) # append the RT you have just calculated

        
        
        # *arithmetic_answer* updates
        if t >= 0.0 and arithmetic_answer.status == NOT_STARTED:
            # keep track of start time/frame for later
            arithmetic_answer.tStart = t
            arithmetic_answer.frameNStart = frameN  # exact frame index
            arithmetic_answer.status = STARTED
            # keyboard checking is just starting
            win.callOnFlip(arithmetic_answer.clock.reset)  # t=0 on next screen flip
            event.clearEvents(eventType='keyboard')
        if arithmetic_answer.status == STARTED:
            theseKeys = event.getKeys(keyList=['num_1', 'num_2', 'num_3', 'num_4', 'num_5', 'num_6', 'num_7', 'num_8', 'num_9', 'num_0'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                arithmetic_answer.keys.extend(theseKeys)  # storing all keys
                arithmetic_answer.rt.append(arithmetic_answer.clock.getTime())
        
        # *experimenter_ends* updates
        if t >= 0.0 and experimenter_ends.status == NOT_STARTED:
            # keep track of start time/frame for later
            experimenter_ends.tStart = t
            experimenter_ends.frameNStart = frameN  # exact frame index
            experimenter_ends.status = STARTED
            # keyboard checking is just starting
            win.callOnFlip(experimenter_ends.clock.reset)  # t=0 on next screen flip
            event.clearEvents(eventType='keyboard')
        if experimenter_ends.status == STARTED:
            theseKeys = event.getKeys(keyList=['return', 'enter'])
            
            # check for quit:
            if "escape" in theseKeys:
                endExpNow = True
            if len(theseKeys) > 0:  # at least one key was pressed
                experimenter_ends.keys = theseKeys[-1]  # just the last key pressed
                experimenter_ends.rt = experimenter_ends.clock.getTime()
                # a response ends the routine
                continueRoutine = False
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in trialComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # check for quit (the Esc key)
        if endExpNow or event.getKeys(keyList=["escape"]):
            core.quit()
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "trial"-------
    for thisComponent in trialComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if solved_arithmetic.keys in ['', [], None]:  # No response was made
        solved_arithmetic.keys=None
    trials.addData('solved_arithmetic.keys',solved_arithmetic.keys)
    if solved_arithmetic.keys != None:  # we had a response
        trials.addData('solved_arithmetic.rt', solved_arithmetic.rt)
        #trials.addData('Log', Log)
    #This section needs to be done either at the end or beginning of the routine. If you put it in each frame, the computer goes schizophrenic, calculating means and SD's
    #every frame, causing it to crash.
    #Define the sound that will be played upon identification
    sound_1 = sound.Sound(u'A', secs=0.3)
    sound_1.setVolume(0.2)
    #add data to the file to tell me the problem that was played, the rolling lower endpoint of the confidence interval of the non-conducives
    #and the rolling median of the conducives
    trials.addData('Stim', play)
    
    
    
    print trial_num
    
    
    #SECTION 1: The non-conducive analysis. 
    #On the first trial it does nothing by way of calculating means/SD's/confidence intervals (this cannot be done with one value).
    #From the second trial onwards it calculates a mean, population SD and a 99% CI of that mean.
    #It has to be a population SD rather than a sample (N-1) SD because a sample SD would add another trial from which it could first be calculated, and more of a delay
    #as to when the identification point could first be calculated. 
    #CI is 3.291 * (SD/SQRT of N). 
    #3.291 = 99.9% 
    
    #Noncducive is 'Ptype' 2 in the excel file. Everything else in this section is a variable in the script, not the excel file.
    #Note that because a mean and SD are not calculated on the first non-conducive trial, 'mean1' 'sd1' actually refer to the next trial - i.e. trial 2.
    if (Ptype == 2) and (nonconducive_count == 1):
        nRT1 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT1)
        print "Ncon Stimulus: ", play
        print "Ncon RT1: ", nRT1
    
    if (Ptype == 2) and (nonconducive_count == 2):
        nRT2 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT2)
        nmean1 = mean([nRT1,nRT2]) #calculate the mean of previous non-conducive trials
        nsd1 = std([nRT1,nRT2]) #calculate the population SD of previous non-conducive trials
        lconf = (nmean1 - (3.291*(nsd1/(sqrt(2))))) # CI calculation that returns the lower endpoint of the confidence interval
        confidence = (3.291*(nsd1/(sqrt(2))))
        print "Ncon Stimulus: ", play
        print "Noncon RT2: ", nRT2
        print "Ncon Mean1: ", nmean1
        print "Ncon SD1: ", nsd1
        print "Ncon LOWER CI1: ", lconf
        trials.addData('Nonconducive_mean',nmean1)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 3):
        nRT3 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT3)
        nmean2 = mean([nRT1,nRT2,nRT3])
        nsd2 = std([nRT1,nRT2,nRT3])
        lconf = (nmean2 - (3.291*(nsd2/(sqrt(3)))))
        confidence = (3.291*(nsd2/(sqrt(3))))
        print "Ncon Stimulus: ", play
        print "Ncon RT3: ", nRT3
        print "Ncon Mean2: ", nmean2
        print "Ncon SD2: ", nsd2
        print "Ncon LOWER CI2: ", lconf
        trials.addData('Nonconducive_mean',nmean2)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 4):
        nRT4 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT4)
        nmean3 = mean([nRT1,nRT2,nRT3,nRT4])
        nsd3 = std([nRT1,nRT2,nRT3,nRT4])
        lconf = (nmean3 - (3.291*(nsd3/(sqrt(4)))))
        confidence = (3.291*(nsd3/(sqrt(4))))
        print "Ncon Stimulus: ", play
        print "Ncon RT4: ", nRT4
        print "Ncon Mean3: ", nmean3
        print "Ncon SD3: ", nsd3
        print "Ncon LOWER CI3: ", lconf
        trials.addData('Nonconducive_mean',nmean3)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 5):
        nRT5 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT5)
        nmean4 = mean([nRT1,nRT2,nRT3,nRT4,nRT5])
        nsd4 = std([nRT1,nRT2,nRT3,nRT4,nRT5])
        lconf = (nmean4 - (3.291*(nsd4/(sqrt(5)))))
        confidence = (3.291*(nsd4/(sqrt(5))))
        print "Ncon Stimulus: ", play
        print "Ncon RT5: ", nRT5
        print "Ncon Mean4: ", nmean4
        print "Ncon SD4: ", nsd4
        print "Ncon LOWER CI4: ", lconf
        trials.addData('Nonconducive_mean',nmean4)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 6):
        nRT6 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT6)
        nmean5 = mean([nRT1,nRT2,nRT3,nRT4,nRT5,nRT6])
        nsd5 = std([nRT1,nRT2,nRT3,nRT4,nRT5,nRT6])
        lconf = (nmean5 - (3.291*(nsd5/(sqrt(6)))))
        confidence = (3.291*(nsd5/(sqrt(6))))
        print "Ncon Stimulus: ", play
        print "Ncon RT6: ", nRT6
        print "Ncon Mean5: ", nmean5
        print "Ncon SD5: ", nsd5
        print "Ncon LOWER CI5: ", lconf
        trials.addData('Nonconducive_mean',nmean5)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 7):
        nRT7 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT7)
        nmean6 = mean([nRT1,nRT2,nRT3,nRT4,nRT5,nRT6,nRT7])
        nsd6 = std([nRT1,nRT2,nRT3,nRT4,nRT5,nRT6,nRT7])
        lconf = (nmean6 - (3.291*(nsd6/(sqrt(7)))))
        confidence = (3.291*(nsd6/(sqrt(7))))
        print "Ncon Stimulus: ", play
        print "Ncon RT7: ", nRT7
        print "Ncon Mean6: ", nmean6
        print "Ncon SD6: ", nsd6
        print "Ncon LOWER CI6: ", lconf
        trials.addData('Nonconducive_mean',nmean6)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 8):
        nRT8 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT8)
        nmean7 = mean([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8])
        nsd7 = std([nRT1,nRT2,nRT3,nRT4,nRT5,nRT6,nRT7,nRT8])
        lconf = (nmean7 - (3.291*(nsd7/(sqrt(8)))))
        confidence = (3.291*(nsd7/(sqrt(8))))
        print "Ncon Stimulus: ", play
        print "Ncon RT8: ", nRT8
        print "Ncon Mean7: ", nmean7
        print "Ncon SD7: ", nsd7
        print "Ncon LOWER CI7: ", lconf
        trials.addData('Nonconducive_mean',nmean7)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 9):
        nRT9 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT9)
        nmean8 = mean([nRT1,nRT2,nRT3,nRT4,nRT5,nRT6,nRT7,nRT8,nRT9])
        nsd8 = std([nRT1,nRT2,nRT3,nRT4,nRT5,nRT6,nRT7,nRT8, nRT9])
        lconf = (nmean8 - (3.291*(nsd8/(sqrt(9)))))
        confidence = (3.291*(nsd8/(sqrt(9))))
        print "Ncon Stimulus: ", play
        print "Ncon RT9: ", nRT9
        print "Ncon Mean8: ", nmean8
        print "Ncon SD8: ", nsd8
        print "Ncon LOWER CI8: ", lconf
        trials.addData('Nonconducive_mean',nmean8)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 10):
        nRT10 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT10)
        nmean9 = mean([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10])
        nsd9 = std([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10])
        lconf = (nmean9 - (3.291*(nsd9/(sqrt(10)))))
        confidence = (3.291*(nsd9/(sqrt(10))))
        print "Ncon Stimulus: ", play
        print "Ncon RT10: ", nRT10
        print "Ncon Mean9: ", nmean9
        print "Ncon SD9: ", nsd9
        print "Ncon LOWER CI9: ", lconf
        trials.addData('Nonconducive_mean',nmean9)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 11):
        nRT11 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT11)
        nmean10 = mean([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10, nRT11])
        nsd10 = std([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10,nRT11])
        lconf = (nmean10 - (3.291*(nsd10/(sqrt(11)))))
        confidence = (3.291*(nsd10/(sqrt(11))))
        print "Ncon Stimulus: ", play
        print "Ncon RT11: ", nRT11
        print "Ncon Mean10: ", nmean10
        print "Ncon SD10: ", nsd10
        print "Ncon LOWER CI10: ", lconf
        trials.addData('Nonconducive_mean',nmean10)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 12):
        nRT12 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT12)
        nmean11 = mean([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10,nRT11, nRT12])
        nsd11 = std([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10, nRT11, nRT12])
        lconf = (nmean11 - (3.291*(nsd11/(sqrt(12)))))
        confidence = (3.291*(nsd11/(sqrt(12))))
        print "Ncon Stimulus: ", play
        print "Ncon RT12: ", nRT12
        print "Ncon Mean11: ", nmean11
        print "Ncon SD11: ", nsd11
        print "Ncon LOWER CI11: ", lconf
        trials.addData('Nonconducive_mean',nmean11)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 13):
        nRT13 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT13)
        nmean12 = mean([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10,nRT11, nRT12, nRT13])
        nsd12 = std([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10, nRT11, nRT12, nRT13])
        lconf = (nmean12 - (3.291*(nsd12/(sqrt(13)))))
        confidence = (3.291*(nsd12/(sqrt(13))))
        print "Ncon Stimulus: ", play
        print "Ncon RT13: ", nRT13
        print "Ncon Mean12: ", nmean12
        print "Ncon SD12: ", nsd12
        print "Ncon LOWER CI12: ", lconf
        trials.addData('Nonconducive_mean',nmean12)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 14):
        nRT14 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT14)
        nmean13 = mean([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10,nRT11, nRT12, nRT13, nRT14])
        nsd13 = std([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10, nRT11, nRT12, nRT13, nRT14])
        lconf = (nmean13 - (3.291*(nsd13/(sqrt(14)))))
        confidence = (3.291*(nsd13/(sqrt(14))))
        print "Ncon Stimulus: ", play
        print "Ncon RT14: ", nRT14
        print "Ncon Mean13: ", nmean13
        print "Ncon SD13: ", nsd13
        print "Ncon LOWER CI13: ", lconf
        trials.addData('Nonconducive_mean',nmean13)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 15):
        nRT15 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT15)
        nmean14 = mean([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10,nRT11, nRT12, nRT13, nRT14, nRT15])
        nsd14 = std([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10, nRT11, nRT12, nRT13, nRT14, nRT15])
        lconf = (nmean14 - (3.291*(nsd14/(sqrt(15)))))
        confidence = (3.291*(nsd14/(sqrt(15))))
        print "Ncon Stimulus: ", play
        print "Ncon RT15: ", nRT15
        print "Ncon Mean14: ", nmean14
        print "Ncon SD14: ", nsd14
        print "Ncon LOWER CI14: ", lconf
        trials.addData('Nonconducive_mean',nmean14)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 16):
        nRT16 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT16)
        nmean15 = mean([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10,nRT11, nRT12, nRT13, nRT14, nRT15, nRT16])
        nsd15 = std([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10, nRT11, nRT12, nRT13, nRT14, nRT15, nRT16])
        lconf = (nmean15 - (3.291*(nsd15/(sqrt(16)))))
        confidence = (3.291*(nsd15/(sqrt(16))))
        print "Ncon Stimulus: ", play
        print "Ncon RT16: ", nRT16
        print "Ncon Mean15: ", nmean15
        print "Ncon SD15: ", nsd15
        print "Ncon LOWER CI15: ", lconf
        trials.addData('Nonconducive_mean',nmean15)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 17):
        nRT17 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT17)
        nmean16 = mean([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10,nRT11, nRT12, nRT13, nRT14, nRT15, nRT16, nRT17])
        nsd16 = std([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10, nRT11, nRT12, nRT13, nRT14, nRT15, nRT16, nRT17])
        lconf = (nmean16 - (3.291*(nsd16/(sqrt(17)))))
        confidence = (3.291*(nsd16/(sqrt(17))))
        print "Ncon Stimulus: ", play
        print "Ncon RT17: ", nRT17
        print "Ncon Mean16: ", nmean16
        print "Ncon SD16: ", nsd16
        print "Ncon LOWER CI16: ", lconf
        trials.addData('Nonconducive_mean',nmean16)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 18):
        nRT18 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT18)
        nmean17 = mean([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10,nRT11, nRT12, nRT13, nRT14, nRT15, nRT16, nRT17, nRT18])
        nsd17 = std([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10, nRT11, nRT12, nRT13, nRT14, nRT15, nRT16, nRT17, nRT18])
        lconf = (nmean17 - (3.291*(nsd17/(sqrt(18)))))
        confidence = (3.291*(nsd17/(sqrt(18))))
        print "Ncon Stimulus: ", play
        print "Ncon RT18: ", nRT18
        print "Ncon Mean17: ", nmean17
        print "Ncon SD17: ", nsd17
        print "Ncon LOWER CI17: ", lconf
        trials.addData('Nonconducive_mean',nmean17)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 19):
        nRT19 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT19)
        nmean18 = mean([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10,nRT11, nRT12, nRT13, nRT14, nRT15, nRT16, nRT17, nRT18, nRT19])
        nsd18 = std([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10, nRT11, nRT12, nRT13, nRT14, nRT15, nRT16, nRT17, nRT18, nRT19])
        lconf = (nmean18 - (3.291*(nsd18/(sqrt(19)))))
        confidence = (3.291*(nsd18/(sqrt(19))))
        print "Ncon Stimulus: ", play
        print "Ncon RT19: ", nRT19
        print "Ncon Mean18: ", nmean18
        print "Ncon SD18: ", nsd18
        print "Ncon LOWER CI18: ", lconf
        trials.addData('Nonconducive_mean',nmean18)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 20):
        nRT20 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT20)
        nmean19 = mean([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10,nRT11, nRT12, nRT13, nRT14, nRT15, nRT16, nRT17, nRT18, nRT19, nRT20])
        nsd19 = std([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10, nRT11, nRT12, nRT13, nRT14, nRT15, nRT16, nRT17, nRT18, nRT19, nRT20])
        lconf = (nmean19 - (3.291*(nsd19/(sqrt(20)))))
        confidence = (3.291*(nsd19/(sqrt(20))))
        print "Ncon Stimulus: ", play
        print "Ncon RT20: ", nRT20
        print "Ncon Mean19: ", nmean19
        print "Ncon SD19: ", nsd19
        print "Ncon LOWER CI19: ", lconf
        trials.addData('Nonconducive_mean',nmean19)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 21):
        nRT21 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT21)
        nmean20 = mean([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10,nRT11, nRT12, nRT13, nRT14, nRT15, nRT16, nRT17, nRT18, nRT19, nRT20, nRT21])
        nsd20 = std([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10, nRT11, nRT12, nRT13, nRT14, nRT15, nRT16, nRT17, nRT18, nRT19, nRT20, nRT21])
        lconf = (nmean20 - (3.291*(nsd20/(sqrt(21)))))
        confidence = (3.291*(nsd20/(sqrt(21))))
        print "Ncon Stimulus: ", play
        print "Ncon RT21: ", nRT21
        print "Ncon Mean20: ", nmean20
        print "Ncon SD20: ", nsd20
        print "Ncon LOWER CI20: ", lconf
        trials.addData('Nonconducive_mean',nmean20)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 22):
        nRT22 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT22)
        nmean21 = mean([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10,nRT11, nRT12, nRT13, nRT14, nRT15, nRT16, nRT17, nRT18, nRT19, nRT20, nRT21, nRT22])
        nsd21 = std([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10, nRT11, nRT12, nRT13, nRT14, nRT15, nRT16, nRT17, nRT18, nRT19, nRT20, nRT21, nRT22])
        lconf = (nmean21 - (3.291*(nsd21/(sqrt(22)))))
        confidence = (3.291*(nsd21/(sqrt(22))))
        print "Ncon Stimulus: ", play
        print "Ncon RT22: ", nRT22
        print "Ncon Mean21: ", nmean21
        print "Ncon SD21: ", nsd21
        print "Ncon LOWER CI21: ", lconf
        trials.addData('Nonconducive_mean',nmean21)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 2) and (nonconducive_count == 23):
        nRT23 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', nRT23)
        nmean22 = mean([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10,nRT11, nRT12, nRT13, nRT14, nRT15, nRT16, nRT17, nRT18, nRT19, nRT20, nRT21, nRT22, nRT23])
        nsd22 = std([nRT1,nRT2,nRT3, nRT4,nRT5,nRT6,nRT7,nRT8, nRT9, nRT10, nRT11, nRT12, nRT13, nRT14, nRT15, nRT16, nRT17, nRT18, nRT19, nRT20, nRT21, nRT22, nRT23])
        lconf = (nmean22 - (3.291*(nsd22/(sqrt(23)))))
        confidence = (3.291*(nsd22/(sqrt(23))))
        print "Ncon Stimulus: ", play
        print "Ncon RT23: ", nRT23
        print "Ncon Mean22: ", nmean22
        print "Ncon SD22: ", nsd22
        print "Ncon LOWER CI22: ", lconf
        trials.addData('Nonconducive_mean',nmean22)
        trials.addData('Confidence',confidence)
        trials.addData('Lower_Nonconinterval',lconf)
    
    
    
    
    #SECTION 2: The conducive analysis.
    #From the second conducive trial onwards, it compares the conducive RT (median) to the lower endpoint of the non-conducive CI. 
    #Conducive RT's are compared to the CI by a 'window' central tendency value. From the 3rd conducive trial onwards, this is a median window. Before the third, means and absolutes are used
    #there are not enough trials to make a 3-window. So, the mean of the first two trials, or the absolute value of the first trial, is comapred to the lower endpoint of the CI.
    #Conducive problems are 'Ptype = 1' in the excel file. All other variables here are created in the script, they are not in the excel file.
    if (Ptype == 1) and (conducive_count == 1):
        cRT1 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT1)
        med = cRT1 # first trial is just RT, not analysed but for completeness in output
        trials.addData('Conducive_median', med)
        print cRT1
        print "Conducive Stimulus: ", play
    
    if (Ptype == 1) and (conducive_count == 2):
        cRT2 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT2)
        med = mean([cRT1, cRT2])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT2
        print "Ncon LOWER CI: ", lconf
        print "Conducive mean: ", med
        if (nonconducive_count > 1) and (med < lconf): #if the median of the conducives is less than the 99% lower-endpoint of the non-conducive confidence interval, record this
            bazinga +=1
            trials.addData('Bazvalue', bazinga) #tell me if, and how many times the median has been below the mean
            print "BAZINGA"
            if bazinga >0:
                sound_1.play() #play a sound when conducive median is first below the non-conducive mean CI, and for every subsequent instance that it is below the CI
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 3):
        cRT3 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT3)
        med = median([cRT1,cRT2,cRT3])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT3
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf): #if the median is less than non-conducive CI on two counts, play a sound, as this is the identification point
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 4):
        cRT4 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT4)
        med = median([cRT2,cRT3,cRT4])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT4
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 5):
        cRT5 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT5)
        med = median([cRT3,cRT4,cRT5])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT5
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 6):
        cRT6 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT6)
        med = median([cRT4,cRT5,cRT6])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT6
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 7):
        cRT7 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT7)
        med = median([cRT5,cRT6,cRT7])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT7
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 8):
        cRT8 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT8)
        med = median([cRT6,cRT7,cRT8])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT8
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 9):
        cRT9 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT9)
        med = median([cRT7,cRT8,cRT9])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT9
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 10):
        cRT10 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT10)
        med = median([cRT8,cRT9,cRT10])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT10
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 11):
        cRT11 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT11)
        med = median([cRT9,cRT10, cRT11])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT11
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 12):
        cRT12 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT12)
        med = median([cRT10, cRT11, cRT12])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT12
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 13):
        cRT13 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT13)
        med = median([cRT11, cRT12, cRT13])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT13
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 14):
        cRT14 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT14)
        med = median([cRT12, cRT13, cRT14])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT14
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 15):
        cRT15 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT15)
        med = median([cRT13, cRT14, cRT15])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT15
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 16):
        cRT16 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT16)
        med = median([cRT14, cRT15, cRT16])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT16
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 17):
        cRT17 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT17)
        med = median([cRT15, cRT16, cRT17])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT17
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 18):
        cRT18 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT18)
        med = median([cRT16, cRT17, cRT18])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT18
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 19):
        cRT19 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT19)
        med = median([cRT17, cRT18, cRT19])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT19
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 20):
        cRT20 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT20)
        med = median([cRT18, cRT19, cRT20])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT20
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 21):
        cRT21 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT21)
        med = median([cRT19, cRT20, cRT21])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT21
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    #Two additional trials code, for if detection occurs on the last conducive sitmulus, we need to this to be confirmed by two subsequent trials. 
    if (Ptype == 1) and (conducive_count == 22):
        cRT22 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT22)
        med = median([cRT20, cRT21, cRT22])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT22
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    if (Ptype == 1) and (conducive_count == 23):
        cRT23 = Log.pop()#popping the RT from the list
        trials.addData('TrialRT', cRT23)
        med = median([cRT21, cRT22, cRT23])
        trials.addData('Conducive_median', med)
        print "Conducive Stimulus: ", play
        print "RT conducive: ", cRT23
        print "Ncon LOWER CI: ", lconf
        print "Median: ", med
        if (nonconducive_count > 1) and (med < lconf):
            bazinga +=1
            trials.addData('Bazvalue', bazinga)
            print "BAZINGA"
            if bazinga >0:
                sound_1.play()
        trials.addData('Lower_Nonconinterval',lconf)
    
    
    
    
    
    
    # check responses
    if arithmetic_answer.keys in ['', [], None]:  # No response was made
        arithmetic_answer.keys=None
    trials.addData('arithmetic_answer.keys',arithmetic_answer.keys)
    if arithmetic_answer.keys != None:  # we had a response
        trials.addData('arithmetic_answer.rt', arithmetic_answer.rt)
        
    # check responses
    if experimenter_ends.keys in ['', [], None]:  # No response was made
        experimenter_ends.keys=None
    trials.addData('experimenter_ends.keys',experimenter_ends.keys)
    if experimenter_ends.keys != None:  # we had a response
        trials.addData('experimenter_ends.rt', experimenter_ends.rt)
    # the Routine "trial" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 1 repeats of 'trials'



# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()